' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                    PC EAMON MUSEUM MAIN MENU                   
'                                                                
'                                        Revision 1: 04 MAY 2012 
'                                        Revision 2: 09 DEC 2012 
'                                            Update: 09 DEC 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
'                         The PC Eamon Museum 2.0
'              http://www.eamonag.org/pages/pc_eamon_museum.htm
' The following applies to the exhibit selection menu and any other original 
' material written by Frank Black (Frank Black Productions, etc. all) that is 
' included in the distributed packages:
' Copyright (C) 2013 Frank Black Productions. The PC Eamon Museum is released 
' as free software under the GNU General Public License and is distributed 
' WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
' or FITNESS FOR A PARTICULAR PURPOSE. For more information write:
'      Free Software Foundation, Inc.
'      59 Temple Place, Suite 330, Boston, MA 02111
'
'You can redistribute it and/or modify it under the terms of the GNU GPL as 
'published by the Free Software Foundation; either version 2 of the License, or 
'(at your option) any later version.

' All included programs, gaming systems (aka "exhibits") and other material 
' is considered the property of the respective author(s) and/or the Public 
' Domain as noted.

DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
ON ERROR GOTO ErrHandler

DIM SHARED BORT, em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27)
mc1 = 1: mc2 = 2: mc3 = 10: q$ = CHR$(34)

GOSUB Header: c = 9: c1 = 12: a$ = INKEY$
CALL EDXMenuM(c, c1, 1, 6, 7, 0)
IF c = 6 OR c1 = 3 THEN LOCATE 24: SYSTEM

'IF (c = 1 OR c = 2) AND BORT <> 1 THEN
'  GOSUB Header: COLOR 15: PRINT : PRINT
'  PRINT "Sorry, the Eamon Deluxe exhibits are not available in the Beta version of the"
'  PRINT "Museum. Please choose a different exhibit to visit...": PRINT
'  PRINT : GOSUB KeyWait: RUN
'END IF

IF c = 1 THEN CHDIR "EDX_4-5\EAMONDX": RUN "EAMONDX"
IF c = 2 THEN CHDIR "EDX_2-6\EAMONDX": RUN "STARTUP"

IF c = 3 THEN
  GOSUB Header: c = 10: c1 = 10: a$ = INKEY$
  CALL EDXMenuM(c, c1, 21, 22, 7, 0)
  CLS : COLOR 7: IF c1 = 3 THEN RUN
  IF c = 2 THEN CLS : CHDIR "EAMON": RUN "WONDERFL"
  adventure$ = q$ + "PC Eamon" + q$ + " (1989-2000)": author$ = "John Nelson"
  GOSUB Title: LOCATE 7: COLOR 2
  PRINT "Notes on the Nelson archive:": PRINT : COLOR 3
  PRINT "Oddly enough, John Nelson contacted me (for the first time ever) just days"
  PRINT "after I had started the PC Eamon Museum project and possibly just hours after I"
  PRINT "had added his system into it. I quickly scripted and sent to him a fresh beta"
  PRINT "installer to check out and he seemed pretty excited about it. He also informed"
  PRINT "me that he had a version that was somewhat newer, had a few more adventures"
  PRINT "converted, and also that he was interested in reviving the development of it."
  PRINT "I offered to pull his exhibit out of the Museum at that point, but he didn't"
  PRINT "seem to mind it's inclusion and said he was going to send me the later version"
  PRINT "from his archives."
  GOSUB KeyWait: COLOR 3: LOCATE 7
  PRINT "We then exchanged a few more messages discussing different programming platforms"
  PRINT "and ways to convert source files before, just as oddly as John had appeared, he"
  PRINT q$; "pulled and Eamon"; q$; " (as I have coined the term) and apparently disappeared off of"
  PRINT "the face of the Earth again. The last message I received from him was dated"
  PRINT "03/08/2012. I waited a month to be fair and then decided to go ahead and finish"
  PRINT "up was now the last unfinished area of the Museum, using the Eamon CD version of"
  PRINT q$; "PC Eamon"; q$; " as my source material."
  GOSUB KeyWait: COLOR 3: LOCATE 7
  PRINT "While the initial appearance and game play may seem just as dated as the Gilbert"
  PRINT "or Walker exhibits, John's PC Eamon ports are actually very nicely coded and"
  PRINT "debugged. I made the minimal modifications to it that were needed for"
  PRINT "compatibility with the Museum setup and, unlike the Gilbert and Walker archives"
  PRINT "before it, I didn't save an untouched copy of the source since it is already"
  PRINT "easily available via the Eamon CD."
  GOSUB KeyWait: COLOR 3: LOCATE 7
  PRINT "All of the unneeded QB45-sourced copies of John's programs were deleted, as well"
  PRINT "as the similarly unneeded executable versions and various utilities programs"
  PRINT "that switched the program names of the three formats around. Having reduced the"
  PRINT "bulkiness of the archive quite a bit, I decided to drop a pre-made character"
  PRINT "into each adventure directory so that visitors may explore this section of the"
  PRINT "Museum at their leisure."
  PRINT
  PRINT "As a final touch, I also reset the ultra bright default colors in each directory"
  PRINT "to be a bit less harsh on the eyes and, in my opinion, better reflect this"
  PRINT "particular Eamon system as well as the time period in which it was created."
  GOSUB KeyWait: COLOR 3: LOCATE 7
  PRINT "While I confess that I didn't thoroughly test each program due to lack of time,"
  PRINT "everything I did test appeared to be working fine and nothing crashed on me"
  PRINT "during my explorations. All in all, John's museum exhibit is very well done and,"
  PRINT "while not being a huge leap in progression from it's classic Apple II"
  PRINT "predecessor, it's definitely one of the more advanced entries into the wide and"
  PRINT "anomalous world of Eamon gaming platforms. It also pleasantly retains that same"
  PRINT "signature Nelson style that many will recognize from his earlier Eamon work."
  GOSUB KeyWait: CLS : CHDIR "EAMON": RUN "WONDERFL"
END IF
IF c = 4 THEN
  adventure$ = "Eamon direct port from 1995": author$ = "Paul Gilbert"
  GOSUB Title: LOCATE 7: COLOR 2
  PRINT "Notes on the Gilbert archive:": PRINT : COLOR 3
  PRINT "As far as I could tell, the Front Desk in Paul Gilbert's port doesn't provide"
  PRINT "an option to list existing characters. Since all of the programs are in compiled"
  PRINT "format, there is no way to know what the structure of the characters file is,"
  PRINT "nor can you break in and modify your character. Also it does not seem to save"
  PRINT "your character when you exit so a new one has to be created upon each visit."
  PRINT
  PRINT "Unmodified copies of the source files which were used to construct this exhibit"
  PRINT "can be found in the Frank Black Productions Archives at ";
  COLOR 2: PRINT "www.eamonag.org"; : COLOR 3: PRINT "."
  'PRINT "can be found in the Museum storage room labeled, "; q$; "PGEAMON\ZIPS"; q$; "."
  GOSUB KeyWait
  CHDIR "PGEAMON": CHDIR "MAIN": SHELL "BLACK.BAT"
  SYSTEM
  END
END IF
Walker:
GOSUB Header: c = 10: c1 = 10: a$ = INKEY$
CALL EDXMenuM(c, c1, 7, 15, 7, 0)
CLS : COLOR 7: IF c1 = 3 THEN RUN
IF c = 9 THEN
  adventure$ = q$ + "Eamon for the PC" + q$: author$ = "Jon Walker"
  GOSUB Title: LOCATE 7: COLOR 2
  PRINT "Notes on the Walker archive:": PRINT : COLOR 3
  PRINT "I renamed all of the .DOC files which were not actually .DOC in the modern"
  PRINT "sense, as well as annoying files like "; q$; "READ.ME"; q$; ", to standard .TXT files for"
  PRINT "easier viewing. I also deleted all of the obsolete batch utilities which"
  PRINT "attempted to send files like "; q$; "READ.ME"; q$; " to a parallel printer."
  PRINT
  PRINT "Unmodified copies of the source files which were used to construct this exhibit"
  PRINT "can be found in the Frank Black Productions Archives at ";
  COLOR 2: PRINT "www.eamonag.org"; : COLOR 3: PRINT "."
  'PRINT "can be found in the Museum storage room labeled, "; q$; "JWEAMON\ZIPS"; q$; "."
  GOSUB KeyWait: GOTO Walker
END IF
CHDIR "JWEAMON"
IF c = 1 THEN CHDIR "JW001-FB": RUN "EAMON"
IF c = 3 THEN CHDIR "JWDD1-1": RUN "MENU"
IF c = 2 THEN CHDIR "JW001-2"
IF c = 4 THEN CHDIR "JW002"
IF c = 5 THEN CHDIR "JW003"
IF c = 6 THEN CHDIR "JW004"
IF c = 7 THEN CHDIR "CRONUM": RUN "RESUME"
IF c = 8 THEN CHDIR "LORD": RUN "RESUME"
SHELL "BLACK.BAT": SYSTEM


'                     ----------------------
'                       USEFUL SUBROUTINES
'                     ----------------------
KeyWait:
COLOR 7
KeyWait1:
PRINT : PRINT
KeyWait2:
PRINT "Press any key to continue...";
KeyWait3:
k$ = INKEY$: k$ = ""
DO
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

Title:
COLOR 15
Title1:
CLS : a$ = adventure$: GOSUB Center: a$ = "by " + author$: GOSUB Center
PRINT STRING$(80, 196): PRINT : COLOR 7: RETURN

Center:
PRINT SPC(INT((80 - LEN(a$)) / 2)); a$: RETURN

Header:
SCREEN 0: WIDTH 80: CLS : COLOR mc1, 0: PRINT ""; STRING$(78, ""); ""
'PRINT ""; SPACE$(78); "":
PRINT ""; SPACE$(9); : COLOR mc3
PRINT "THE EAMON PRESERVATION PROJECT: MUSEUM OF PC EAMON CONVERSIONS";
COLOR mc1: PRINT SPACE$(7); "":
PRINT ""; SPACE$(14); : COLOR mc2
PRINT "Funded by The Marvelous World of Eamon Deluxe v5.0";
COLOR mc1: PRINT SPACE$(14); "":
PRINT ""; SPACE$(78); ""
PRINT ""; : PRINT STRING$(78, ""); "": PRINT : RETURN

'                       ------------
'                        Error trap
'                       ------------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; STR$(ERR); ")": PRINT
k$ = "try and continue": IF ERR > 51 THEN k$ = "exit to Main Menu"
PRINT SPACE$(20); "Hit any key to "; k$; "...": k$ = INKEY$: k$ = ""
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN PRINT "FILE ERROR": END
PRINT "ATTEMPTING TO CONTINUE...": PRINT : L = 0: COLOR 7: RESUME NEXT

EDXMenuStrings:
DATA 22
DATA " Visit Eamon Deluxe 4.5 (2007) "
DATA " Visit Eamon Deluxe 2.6 (1999) "
DATA " Visit John Nelson's PC Eamon (2000) "
DATA " Visit Paul Gilbert's PC Eamon (1995) "
DATA " Visit Jon Walker's PC Eamon (1985) "
DATA " Leave the Museum "
DATA " Walker's Main Hall 1.1 (modified by Frank Black) "
DATA " Walker's Main Hall 2.2 (compiled version only) "
DATA " Walker's Dungeon Designer (untested) "
DATA " Adventure #2: Ice Cave (compiled) "
DATA " Adventure #3: Assault on the Clone Master (compiled) "
DATA " Adventure #4: The Quest for Trezore (compiled) "
DATA " Lost Adventure: Cronum's Castle "
DATA " Lost Adventure: Lord of the Underland "
DATA " Notes on Jon Walker's PC Eamon "
DATA " [reserved] "
DATA " [reserved] "
DATA " [reserved] "
DATA " [reserved] "
DATA " [reserved] "
DATA " Read Pamphlet About John Nelson's PC Eamon "
DATA " Skip the Pamphlet and Proceed to the Exhibit "

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
'// Compact Eamon Deluxe Selection Menu 5.0           Revision 2: 20 JUN 2012
'     User locatable, two colors, single choice row with no error checking
'
'  Passed to SUB:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'  Modified by SUB:
'   ad/v/x/k/k$ - used as generic
'  Returned by SUB:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'  Required SHARED:
'   em0 - The maximum dimension of the em$() array
'em$(x) - em$(0) holds exit keys, em$(1-x) hold user defined choices

IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, 0
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT
EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1: LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, 0: PRINT em$(c);
IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF
GOSUB EDXMenuMB: IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
'
' Make sure input is a valid ANSI code, else recode in ASCII (=SPOT)
EDXMenuMB:
IF k = 98 AND BORT = 0 THEN BORT = 2: SOUND 250, .5:
IF k = 111 AND BORT = 2 THEN BORT = 3: SOUND 350, .5:
IF k = 114 AND BORT = 3 THEN BORT = 4: SOUND 450, .5:
IF k <> 116 OR BORT <> 4 THEN RETURN:  ELSE BORT = 1: SOUND 550, .5:                                                                                                                                                      'B O R T = S P O T
END SUB

