' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                                                                
'                   By Frank Black 1997-1999                     
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'   DUNGEON EDITOR                           Update: 1 JUL 1999  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'CHDIR "c:\eamondx\dd"

TYPE ADV
   ANAME AS STRING * 78
   NUMBER AS INTEGER
END TYPE
DIM ADV AS ADV
OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly, CC1, CC2, CC3: CLOSE
CC1 = INT(dly / 8.6): CC2 = CC1 * 2
'
' Load design names
'
OPEN "DGNDIR.DAT" FOR INPUT AS #1
INPUT #1, d1, d2
CLOSE
IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d1$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d2$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
'
' Load adventure names
'
CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
GET #2, 1, ADV
numadv = ADV.NUMBER: numadv1 = numadv
DIM an$(numadv + 2), anum(numadv + 2)

FOR a = 2 TO numadv + 1
   GET #2, a, ADV
   an$(a - 1) = LTRIM$(RTRIM$(ADV.ANAME$))
NEXT
CLOSE : CHDIR "DD"
IF d1 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d1$ + "  (Design 1)"
END IF
IF d2 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d2$ + "  (Design 2)"
END IF
'
' Change to proper directory
'
Start:
CLS : L = 0
PRINT "Select adventure to edit."
FOR a = 1 TO numadv
   a$ = LTRIM$(RTRIM$(STR$(a))) + ": " + an$(a)
   PRINT a$
   L = L + 1
   IF L = 20 THEN
      PRINT "Hit any key to continue...";
      DO
      LOOP UNTIL INKEY$ <> ""
      L = 0
   END IF
NEXT
PRINT
LINE INPUT "Enter the number of your choice:"; a$
a = INT(VAL(a$))
IF a < 1 OR a > numadv THEN GOTO Start
a$ = LTRIM$(RTRIM$(STR$(a)))
ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
IF a = numadv1 + 1 THEN ad$ = "DGN-1"
IF a = numadv1 + 2 OR (a = numadv1 + 1 AND d1 = 0) THEN ad$ = "DGN-2"
CHDIR "..": CHDIR ad$

'----------------------------------------------------------------------------
TYPE DESC
TEXT AS STRING * 255
END TYPE
DIM DS AS DESC

TYPE ROOM
RNAME AS STRING * 79: d1 AS INTEGER: d2 AS INTEGER: D3 AS INTEGER
D4 AS INTEGER: D5 AS INTEGER: D6 AS INTEGER: D7 AS INTEGER: D8 AS INTEGER:
D9 AS INTEGER: D10 AS INTEGER: LIGHT AS INTEGER
END TYPE
DIM RM AS ROOM

TYPE ARTIFACT
ANAME AS STRING * 35: AD1 AS INTEGER: AD2 AS INTEGER: AD3 AS INTEGER:
AD4 AS INTEGER: AD5 AS INTEGER: AD6 AS INTEGER: AD7 AS INTEGER:
AD8 AS INTEGER
END TYPE
DIM ART AS ARTIFACT

TYPE MONSTER
MNAME AS STRING * 35: MD1 AS INTEGER: MD2 AS INTEGER: MD3 AS INTEGER:
MD4 AS INTEGER: MD5 AS INTEGER: MD6 AS INTEGER: MD7 AS INTEGER:
MD8 AS INTEGER: MD9 AS INTEGER: MD10 AS INTEGER: MD11 AS INTEGER
MD12 AS INTEGER: MD13 AS INTEGER
END TYPE
DIM MON AS MONSTER

OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, N%(1), N%(2), N%(3), N%(4), ANAME$, nd, ver, dungeons
IF dungeons > 1 THEN
  DIM dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a)
     FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
     IF dn%(a, 9) > 6 THEN nd = 10
  NEXT
END IF
CLOSE

OPEN "ROOMS.DAT" FOR RANDOM AS #1 LEN = 101
OPEN "ARTIFACT.DAT" FOR RANDOM AS #2 LEN = 51
OPEN "MONSTERS.DAT" FOR RANDOM AS #3 LEN = 61

OPEN "ROOMS.DSC" FOR RANDOM AS #10 LEN = 255
OPEN "ARTIFACT.DSC" FOR RANDOM AS #11 LEN = 255
OPEN "MONSTERS.DSC" FOR RANDOM AS #12 LEN = 255
OPEN "EFFECT.DSC" FOR RANDOM AS #13 LEN = 255


DIM RD%(11), a%(8), T$(4)
FOR a = 1 TO 4
   READ T$(a)
NEXT
DIM D$(10)
FOR a = 1 TO 10
   READ D$(a)
NEXT
BS$ = CHR$(29): columns = 80: clr = 6
'
' READ ARTIFACT DATA
'
READ nf: DIM ty$(nf), F$(nf, 3), DF(nf, 3)
FOR a = 0 TO nf
   READ ty$(a)
   FOR a2 = 0 TO 3
      READ F$(a, a2), DF(a, a2)
   NEXT
NEXT
'
' READ MONSTER DATA
'
MF = 13: DIM m%(MF), MF$(MF), MD(MF)
FOR a = 1 TO MF
   READ MF$(a), MD(a)
NEXT

DATA Room,Artifact,Effect,Monster
DATA N ,S ,E ,W ,U ,D ,NE,NW,SE,SW
'
' ARTIFACT DATA
'
DATA 16
DATA Gold,User #5,0,User #6,0,User #7,0,User #8,0
DATA Treasure,User #5,0,User #6,0,User #7,0,User #8,0
DATA Weapon,Odds,10,Type,5,Dice,1,Sides,4
DATA Magic Weapon,Odds,10,Type,5,Dice,1,Sides,10
DATA Container,Key#,0,Open/Closed,0,# of items inside,0,# of items can hold,0
DATA Light,Counter,999,User #6,0,User #7,0,User #8,0
DATA Drinkable,Heal amount,10,# of uses,5,Open/Closed,1,User #8,0
DATA Readable,1st effect,1,# of effects,1,Open/Closed,1,User #8,0
DATA Door/Gate,Room beyond,1,Key#,0,Open/Closed,1,Hidden?,0
DATA Food,Heal amount,10,# of uses,5,Open/Closed,1,User #8,0
DATA Bound monster,Monster#,1,Key #,0,Guard#,0,User #8,0
DATA Wearable,Armor class,0,Type,0,User #7,0,User #8,0
DATA Disguised monster,Monster #,0,# of first effect,0,# of effects,0,User #8,0
DATA Dead body,GET status,0,User #6,0,User #7,0,User #8,0
DATA USER TYPE#1,User #5,0,User #6,0,User #7,0,User #8,0
DATA USER TYPE#2,User #5,0,User #6,0,User #7,0,User #8,0
DATA USER TYPE#3,User #5,0,User #6,0,User #7,0,User #8,0
'
' MONSTER DATA
'
DATA Hardiness,16,Agility,16,# Members in group,1,Courage,100,Room,0
DATA Combat Code,0,Armor,0,Weapon #,0,Wep. dice,1,Wep. sides,4
DATA Friendliness,3,USER #1,0,USER #2,0

'---------------------------------------------------------------------------
' Main loops
'
Menu:
NW = 0: CLS : COLOR 6: PRINT
FOR T = 1 TO 4
   PRINT T$(T); "-"; N%(T);
NEXT
LOCATE 4, 4: PRINT "Editing: "; ANAME$:  PRINT
PRINT "Your choices are--": PRINT
PRINT "  1. Add a new Room, Artifact, Monster or Effect.": PRINT
PRINT "  2. Edit old Room, Artifact, Monster or Effect.": PRINT
PRINT "  3. List names of Rooms, Artifacts, etc.": PRINT
PRINT "  4. Duplicate a Room, Artifact, or Monster.": PRINT
PRINT "  5. Special functions.": PRINT
PRINT "  6. Quit.": PRINT
PRINT "Enter key of your choice (1-6): ";
GOSUB GetKey: c = INT(VAL(a$)): IF c < 1 OR c > 6 THEN GOTO Menu
ON c GOTO Add, Edit, EList, Duplicate, Special, Quit


'---------------------------------------------------------------------------
'   Add stuff
'
Add:
c$ = "add": GOSUB ESelect: IF ty = 0 THEN GOTO Menu
N%(ty) = N%(ty) + 1
NO = N%(ty): RE = N%(ty): UP = 1
ON ty GOTO AddRoom, AddArtifact, AddEffect, AddMonster

AddRoom:
na$ = "": DE$ = "": LT = 1
FOR a = 1 TO nd
   RD%(a) = 0
NEXT
GOSUB EditRoom
GOSUB WriteRoom
RE = NO: GOSUB WriteDesc1
GOTO Menu

AddArtifact:
na$ = "": DE$ = "": NW = 1
GOSUB EditArtifact
GOSUB WriteArtifact
RE = NO: GOSUB WriteDesc2
GOTO Menu

AddEffect:
DE$ = ""
GOSUB EditEffect
RE = NO: GOSUB WriteDesc4
GOTO Menu

AddMonster:
na$ = "": DE$ = ""
FOR a = 1 TO MF
   m%(a) = MD(a)
NEXT
GOSUB EditMonster
GOSUB WriteMonster
RE = NO: GOSUB WriteDesc3
GOTO Menu

'---------------------------------------------------------------------------
' Edit stuff
'
Edit:
c$ = "edit": GOSUB ESelect: IF ty = 0 THEN GOTO Menu
GOSUB ESelectNo: NW = 0: RE = NO
ON ty GOTO EdRoom, EdArtifact, EdEffect, EdMonster

EdRoom:
GOSUB ReadDesc1
GOSUB ReadRoom: GOSUB EditRoom: GOSUB WriteRoom: GOSUB WriteDesc1: GOTO Menu

EdArtifact:
GOSUB ReadDesc2
GOSUB ReadArtifact: GOSUB EditArtifact: GOSUB WriteArtifact
GOSUB WriteDesc2: GOTO Menu

EdEffect:
GOSUB ReadDesc4
GOSUB EditEffect
GOSUB WriteDesc4
GOTO Menu

EdMonster:
GOSUB ReadDesc3
GOSUB ReadMonster: GOSUB EditMonster: GOSUB WriteMonster
GOSUB WriteDesc3: GOTO Menu

'
' Actually edit the stuff
'
EditRoom:
CLS : PRINT "Entering room "; NO; ".": PRINT
i$ = na$: tl = 79: PRINT "Enter room name:": GOSUB TextInput
na$ = i$: tl = 255: i$ = DE$: PRINT "Enter room Description:"
GOSUB TextInput: DE$ = i$
PRINT "For each direction, enter the room # that this room conects to.": PRINT
PRINT "  No connection:  0": PRINT "  Exit to Main Hall: -999"
PRINT "  Doors: Artifact # of door + 1000"
PRINT "  Negative numbers for unusual things.": PRINT
FOR D = 1 TO nd
   PRINT "Move "; D$(D); ": ";
   i$ = LTRIM$(STR$(RD%(D))): tl = 6
   GOSUB NumInput
   RD%(D) = INT(VAL(i$))
NEXT
PRINT "Light (0 = Dark; 1 = Light) ";
i$ = LTRIM$(STR$(LT)): GOSUB NumInput: LT = INT(VAL(i$))
RETURN

'
EditArtifact:
'
PRINT "Entering Artifact "; NO; ".": PRINT
PRINT "Enter Artifact name:": i$ = na$: tl = 35: GOSUB TextInput

PRINT "Artifact description:"
na$ = i$: i$ = DE$: tl = 255: GOSUB TextInput: DE$ = i$

IF NW THEN a%(1) = 50: a%(2) = 1: a%(3) = 3: a%(4) = 0

a$ = "Value": AA = 1:  GOSUB EdArt
a$ = "Type": AA = 2

XX = INT(nf / 2) + 1
FOR x = 1 TO XX
  PRINT " "; x - 1; " = "; ty$(x - 1);
  IF x - 1 + XX <= nf THEN
     LOCATE CSRLIN, 39 + (ABS(x - 1 + XX < 10))
     PRINT x - 1 + XX; " = "; ty$(x - 1 + XX);
  END IF
  PRINT
NEXT
GOSUB EdArt

a$ = "Weight": AA = 3: q$ = CHR$(34)
PRINT " 999................"; q$; "Don't be absurd!"; q$
PRINT "-999..............."; q$; "You can't get that."; q$: PRINT
GOSUB EdArt

a$ = "Room": AA = 4
PRINT "-1.................Carried by player"
PRINT "(- Monster# - 1)...Monster# carrying it"
PRINT "Artifact# + 1000...Inside Artifact#"
PRINT "Room# + 2000........Embedded in Room#"
PRINT "-999...............Worn by Player"
PRINT "(-1000 -Monster#)..Monster# wearing it": PRINT
GOSUB EdArt

IF a%(2) > nf THEN a%(2) = nf
tp = a%(2)

FOR AR = 5 TO 8
   IF NW = 1 THEN a%(AR) = DF(tp, AR - 5)
   IF (AR = 7 AND (tp = 6 OR tp = 7 OR tp = 9)) OR (AR = 6 AND tp = 4) THEN
      PRINT "Open = 1;  Closed = 0"
      IF tp = 4 THEN PRINT "1000 + Damage if it must be broken open."
      PRINT
   END IF
   IF tp = 8 AND AR = 7 THEN
     PRINT "Open = 0;  Closed = 1;  100+Damage = Must be forced open": PRINT
   END IF
   IF (tp = 2 OR tp = 3) AND AR = 6 THEN
      PRINT "1=Axe, 2=Bow, 3=Club, 4=Spear, 5=Sword": PRINT
      PRINT "Guns should be type 2, Knives and daggers should be type 4": PRINT
   END IF
   IF tp = 4 AND AR = 8 THEN
     PRINT "0 = Player can't put anything in it": PRINT
   END IF
   IF tp = 5 AND AR = 5 THEN
     PRINT "-1 = Never runs out": PRINT
   END IF
   IF tp = 8 AND AR = 8 THEN
     PRINT "1 = Hidden": PRINT
   END IF
   IF tp = 11 AND AR = 5 THEN
     PRINT "0 = Clothing           4 = Chain mail"
     PRINT "1 = Shield, Helmet     6 = Plate armor"
     PRINT "2 = Leather armor": PRINT
   END IF
   IF tp = 11 AND AR = 6 THEN
     PRINT "0 = Armor, shields       3 = Gloves"
     PRINT "1 = Overclothes          4 = Hats, Headwear"
     PRINT "2 = Shoes, Boots         5 = Jewlery": PRINT
   END IF
   IF tp = 13 AND AR = 5 THEN
     PRINT "1 = Can be taken"
     PRINT "(Should normally be 0)": PRINT
   END IF
   IF tp > nf THEN PRINT "Field #"; AR; ": ";
   IF tp <= nf THEN PRINT F$(tp, AR - 5); ": ";
   i$ = LTRIM$(STR$(a%(AR))): GOSUB NumInput
   IF INT(VAL(i$)) > 9999 THEN i$ = "9999"
   a%(AR) = INT(VAL(i$))
NEXT: RETURN

EdArt:
PRINT a$; ": "; : i$ = LTRIM$(STR$(a%(AA))): tl = 6: GOSUB NumInput
a%(AA) = INT(VAL(i$))
RETURN

'
EditEffect:
'
PRINT "Enter Effect #"; NO; ":": PRINT
i$ = DE$: tl = 255: GOSUB TextInput: DE$ = i$
RETURN

'
EditMonster:
'
PRINT "Entering Monster #"; NO; ":": PRINT
PRINT "** Be sure to enter *ALL* monster names in a singular form **": PRINT
PRINT "Enter name of monster:": i$ = na$: tl = 35: GOSUB TextInput: na$ = i$

PRINT "Enter description:": i$ = DE$: tl = 255: GOSUB TextInput: DE$ = i$

CLS : PRINT "Monster #"; NO; "   "; na$: PRINT : GOSUB MonInfo
FOR m = 1 TO MF
   IF m = 3 THEN
     PRINT "   Single Monsters - Enter 1"
     PRINT "   Group Monsters  - Enter # of members"
     PRINT
   END IF
   IF m = 4 THEN
     PRINT "1-100% Chance monster will not flee and follow fleeing player (if enemy)"
     PRINT "If monster is injured fleeing chance is increased 5%"
     PRINT "If monster is near-death fleeing chance is increased 10%"
     PRINT "200% courage will never flee and always follow player": PRINT
   END IF
   IF m = 6 THEN
     PRINT " 1 = Combat text reads '[mon] ATTACKS' only (instead of tear, lunge, etc.)"
     PRINT " 0 = Normal"
     PRINT "-1 = Will use natural weapons when a weapon isn't available"
     PRINT "-2 = Will never fight at all": PRINT
   END IF
   IF m = 7 THEN
      GOSUB MonInfo
      PRINT : PRINT "0 = None, 1 = Leather, 2 = Chain, 3 = Plate": PRINT
   END IF
   IF m = 8 THEN
      PRINT "   Artifact #...Weapon"
      PRINT "   0............Natural Weapons"
      PRINT "   -1...........Weaponless"
      PRINT
   END IF
   IF m = 9 THEN
     PRINT "Enter values for monster's natural weapons.": PRINT
   END IF
   IF m = 11 THEN
     PRINT "   1=Enemy  2=Neutral  3=Friend"
     PRINT "For random Friendliness enter percent likely friendly + 100"
     PRINT
   END IF
   PRINT "Enter "; MF$(m); ": ";
   i$ = LTRIM$(STR$(m%(m))): tl = 5: GOSUB NumInput
   m%(m) = VAL(i$)
NEXT
RETURN
MonInfo:
COLOR 3
PRINT "Weak monsters:  This includes small creatures like rats and kobolds."
PRINT "Medium monsters: Including thugs, orcs, goblins."
PRINT "Tough monsters: Including giants, trained warriors, trolls."
PRINT "Super tough: Such as dragons and demons."
PRINT
PRINT "           Weak       Medium     Tough      Super tough"
PRINT "---------------------------------------------------------"
PRINT "Hardiness:   2-8        9-15     16-30       31-90"
PRINT "Agility  :   5-9       10-16     17-24       25-35"
PRINT "Courage  :  80-90%     95-100%    200%        200%"
PRINT "Armor    :    0         1         2-3         3+"
PRINT "Nat. Damg:   1D4       1D6-1D10  1D10-2D6     2D8+"
PRINT
PRINT "If group monster then enter value for just one member of group."
PRINT : COLOR 6
RETURN
'---------------------------------------------------------------------------
' List stuff
'
EList:
c$ = "list": GOSUB ESelect: IF ty = 0 THEN GOTO Menu
IF N%(ty) = 0 THEN
  PRINT "None of that type to print!"; : GOSUB GetKey: GOTO Menu
END IF
CLS : L = 0
ON ty GOTO LRooms, LArtifacts, LEffects, LMonsters

LRooms:
a$ = "Listing Rooms:": GOSUB EList2: a$ = "": GOSUB EList2
FOR NO = 1 TO N%(1)
   GOSUB ReadRoom: a$ = STR$(NO) + ": " + na$: GOSUB EList2
NEXT: L = 99: a$ = "": GOSUB EList2: GOTO Menu

LArtifacts:
a$ = "Listing Artifacts:": GOSUB EList2: a$ = "": GOSUB EList2
FOR NO = 1 TO N%(2)
   GOSUB ReadArtifact: a$ = STR$(NO) + ": " + na$: GOSUB EList2
NEXT: L = 99: a$ = "": GOSUB EList2: GOTO Menu

LEffects:
a$ = "Listing Effects:": GOSUB EList2: a$ = "": GOSUB EList2
FOR NO = 1 TO N%(3)
   GOSUB ReadDesc4: a$ = "Effect #" + STR$(NO) + ":": GOSUB EList2
LEff:
   IF LEN(DE$) > 79 THEN
     a$ = LEFT$(DE$, 79): DE$ = MID$(DE$, 80): GOSUB EList2: GOTO LEff
   END IF
   a$ = DE$: GOSUB EList2: a$ = "": GOSUB EList2
NEXT: L = 99: a$ = "": GOSUB EList2: GOTO Menu

LMonsters:
a$ = "Listing Monsters:": GOSUB EList2: a$ = "": GOSUB EList2
FOR NO = 1 TO N%(4)
   GOSUB ReadMonster: a$ = STR$(NO) + ": " + na$: GOSUB EList2
NEXT: L = 99: a$ = "": GOSUB EList2: GOTO Menu


EList2:
IF PT = 1 THEN LPRINT a$: RETURN
PRINT a$: L = L + 1
IF L < 22 THEN RETURN
PRINT "Hit any key..."; : GOSUB GetKey: L = 0: CLS : RETURN

'---------------------------------------------------------------------------
Duplicate:
c$ = "Duplicate": GOSUB ESelect: IF ty = 0 THEN GOTO Menu
c$ = "Duplicate from": GOSUB ESelectNo
FR = NO
c$ = "create": GOSUB ESelectNo
NC = NO
IF NO <= N%(ty) THEN
  PRINT "Overwrite "; T$(ty); " #"; LTRIM$(RTRIM$(STR$(NO)));
  PRINT "?  (Y/N):"; : GOSUB GetKey: IF a$ <> "Y" THEN GOTO Menu
END IF
CLS : IF NO > N%(ty) + 1 THEN NO = N%(ty) + 1
IF NO > N%(ty) THEN
  PRINT "Creating a "; T$(ty); " from another."
  N%(ty) = N%(ty) + 1: UP = 1
END IF
NO = FR
ON ty GOTO DupR, DupA, DupE, DupM

DupR:
GOSUB ReadDesc1
GOSUB ReadRoom: RE = NC: NO = NC
GOSUB EditRoom: GOSUB WriteRoom: GOSUB WriteDesc1: GOTO Menu

DupA:
GOSUB ReadDesc2
GOSUB ReadArtifact: RE = NC: NO = NC
GOSUB EditArtifact: GOSUB WriteArtifact: GOSUB WriteDesc2: GOTO Menu

DupE:
GOSUB ReadDesc4
RE = NC: GOSUB WriteDesc4: GOTO Menu

DupM:
GOSUB ReadDesc3
GOSUB ReadMonster: RE = NC: NO = NC
GOSUB EditMonster: GOSUB WriteMonster: GOSUB WriteDesc3: GOTO Menu

'---------------------------------------------------------------------------
Special:
CLS
PRINT "Rooms-"; N%(1); " Art-"; N%(2); " Effects-"; N%(3); " Monsters-"; N%(4)
PRINT : PRINT "   Select function or press <Enter>": PRINT
PRINT "  1. Delete last R, A, E, M"
PRINT "  2. Add to number of R, A, E, M"
PRINT "  3. Generate dummy artifacts"
PRINT "  4. Generate dead bodies"
PRINT "  5. Turn printer "; MID$("offon", ABS(PT = 0) * 3 + 1, 3)
PRINT "  6. (not used)"
PRINT "  7. (not used)"
PRINT "  8. (not used)": PRINT
PRINT "Enter the no. of your choice (1-8): ";
GOSUB GetKey: c = INT(VAL(a$)): IF c < 1 OR c > 8 THEN GOTO Menu
ON c GOTO SP1, SP2, SP3, SP4, SP5, SP6, SP7, SP8

'  Special 1, decrement amount of type
'
SP1:
c$ = "delete": GOSUB ESelect: IF ty = 0 THEN GOTO Menu
IF N%(ty) = 0 THEN GOTO Special
N%(ty) = N%(ty) - 1: UP = 1: GOTO Special

'  Special 2, increment amount of type
'
SP2:
c$ = "increment": GOSUB ESelect: IF ty = 0 THEN GOTO Menu
IF N%(ty) = 400 AND ty <> 3 THEN GOTO Special
N%(ty) = N%(ty) + 1: UP = 1: GOTO Special

' Create "Dummy" artifacts
'
SP3:
CLS : LINE INPUT "How many to generate?:"; a$: a = INT(VAL(a$))
IF a < 1 THEN GOTO Special
IF a + N%(2) > 400 THEN
 PRINT "You can only have a maximum of 400 artifacts.";
 GOSUB GetKey: GOTO Special
END IF
UP = 1
FOR x = 1 TO a
   N%(2) = N%(2) + 1
   na$ = "Artifact #" + LTRIM$(RTRIM$(STR$(N%(2))))
   FOR c = 1 TO 8
      a%(c) = 0
   NEXT
   DE$ = "You see artifact #" + LTRIM$(RTRIM$(STR$(N%(2))))
   NO = N%(2): RE = NO
   GOSUB WriteArtifact: GOSUB WriteDesc2
NEXT: GOTO Special

' Generate dead bodies
'
SP4:
CLS : PRINT ">>>>  NOTE  <<<<": PRINT
PRINT "Before using this option make sure that you have read the DEAD BODIES"
PRINT "section of the designer manual and you are completely sure you want to"
PRINT "use dead bodies.": PRINT
PRINT "Continue? (Y/N):"; : GOSUB GetKey: IF a$ <> "Y" THEN GOTO Special

LINE INPUT "# of monster to start with:"; a$: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > N%(4) THEN GOTO Special
T = N%(4) + 1 - a
UP = 1
FOR x = a TO N%(4)
   NO = x
   GOSUB ReadMonster
   N%(2) = N%(2) + 1
   na$ = na$ + "'s body"
   FOR c = 1 TO 8: a%(c) = 0: NEXT
   a%(2) = 13: a%(3) = -999
   DE$ = "You see " + na$ + "."
   NO = N%(2): RE = NO
   GOSUB WriteArtifact: GOSUB WriteDesc2
NEXT: GOTO Special

' Toggle printer
'
SP5:
PT = ABS(PT = 0): GOTO Special

' Special 6-8, this space for rent
'
SP6:
GOTO Special

SP7:
GOTO Special

SP8:
GOTO Special

'---------------------------------------------------------------------------
Quit:
CLOSE
IF UP = 1 THEN
   OPEN "NAME.DAT" FOR OUTPUT AS #1
   PRINT #1, N%(1), N%(2), N%(3), N%(4): PRINT #1, ANAME$
   PRINT #1, nd, ver, dungeons
   IF dungeons > 1 THEN
     FOR a = 1 TO dungeons
        PRINT #1, dn$(a)
        FOR m = 1 TO 9: PRINT #1, dn%(a, m): NEXT
     NEXT
   END IF
   CLOSE
END IF
CHDIR ".."
CHDIR "DD"
RUN "DDMENU.BAS"

'---------------------------------------------------------------------------
' Select what to work on
'
ESelect:
CLS : PRINT
FOR T = 1 TO 4
   PRINT T$(T); "-"; N%(T);
NEXT: PRINT : PRINT
PRINT "Do you want to "; c$;
PRINT " a Room, Artifact, Effect or Monster (or hit X to exit)"
PRINT "  Hit a key (RAEMX): "; : GOSUB GetKey
IF a$ = "X" THEN ty = 0: RETURN
IF a$ <> "R" AND a$ <> "A" AND a$ <> "E" AND a$ <> "M" THEN GOTO ESelect
IF a$ = "R" THEN ty = 1
IF a$ = "A" THEN ty = 2
IF a$ = "E" THEN ty = 3
IF a$ = "M" THEN ty = 4
CLS : RETURN
'-----------------------------------------------------
' Select number of item to work on
'
ESelectNo:
CLS : PRINT
FOR T = 1 TO 4
   PRINT T$(T); "-"; N%(T);
NEXT: PRINT : PRINT
PRINT "Input number of "; T$(ty); " to "; c$
PRINT "   (1-"; LTRIM$(RTRIM$(STR$(N%(ty)))); : INPUT "): "; a$
NO = INT(VAL(a$))
IF NO < 1 OR NO > N%(ty) + ABS(c$ = "create") THEN GOTO ESelectNo
CLS : RETURN
'--------------------------------------------------------
'   Input data from files
'
ReadRoom:
GET #1, NO, RM
na$ = RTRIM$(RM.RNAME): RD%(1) = RM.d1: RD%(2) = RM.d2: RD%(3) = RM.D3
RD%(4) = RM.D4: RD%(5) = RM.D5: RD%(6) = RM.D6: RD%(7) = RM.D7
RD%(8) = RM.D8: RD%(9) = RM.D9: RD%(10) = RM.D10
LT = RM.LIGHT
RETURN

ReadArtifact:
GET #2, NO, ART
na$ = RTRIM$(ART.ANAME): a%(1) = ART.AD1: a%(2) = ART.AD2: a%(3) = ART.AD3
a%(4) = ART.AD4: a%(5) = ART.AD5: a%(6) = ART.AD6: a%(7) = ART.AD7
a%(8) = ART.AD8
RETURN

ReadMonster:
GET #3, NO, MON
na$ = RTRIM$(MON.MNAME): m%(1) = MON.MD1: m%(2) = MON.MD2: m%(3) = MON.MD3
m%(4) = MON.MD4: m%(5) = MON.MD5: m%(6) = MON.MD6: m%(7) = MON.MD7
m%(8) = MON.MD8: m%(9) = MON.MD9: m%(10) = MON.MD10: m%(11) = MON.MD11
m%(12) = MON.MD12: m%(13) = MON.MD13
RETURN

ReadDesc1:
GET #10, NO, DS
DE$ = RTRIM$(DS.TEXT)
RETURN

ReadDesc2:
GET #11, NO, DS
DE$ = RTRIM$(DS.TEXT)
RETURN

ReadDesc3:
GET #12, NO, DS
DE$ = RTRIM$(DS.TEXT)
RETURN

ReadDesc4:
GET #13, NO, DS
DE$ = RTRIM$(DS.TEXT)
RETURN
'---------------------------------------------------------------------------
'   Output data to files
'
WriteRoom:
RM.RNAME = na$: RM.d1 = RD%(1): RM.d2 = RD%(2): RM.D3 = RD%(3)
RM.D4 = RD%(4): RM.D5 = RD%(5): RM.D6 = RD%(6): RM.D7 = RD%(7)
RM.D8 = RD%(8): RM.D9 = RD%(9): RM.D10 = RD%(10)
RM.LIGHT = LT
PUT #1, NO, RM
RETURN

WriteArtifact:
ART.ANAME = na$: ART.AD1 = a%(1): ART.AD2 = a%(2): ART.AD3 = a%(3)
ART.AD4 = a%(4): ART.AD5 = a%(5): ART.AD6 = a%(6): ART.AD7 = a%(7)
ART.AD8 = a%(8)
PUT #2, NO, ART
RETURN

WriteMonster:
MON.MNAME = na$: MON.MD1 = m%(1): MON.MD2 = m%(2): MON.MD3 = m%(3)
MON.MD4 = m%(4): MON.MD5 = m%(5): MON.MD6 = m%(6): MON.MD7 = m%(7)
MON.MD8 = m%(8): MON.MD9 = m%(9): MON.MD10 = m%(10): MON.MD11 = m%(11):
MON.MD12 = m%(12): MON.MD13 = m%(13):
PUT #3, NO, MON
RETURN

WriteDesc1:
DS.TEXT = DE$: PUT #10, RE, DS
RETURN

WriteDesc2:
DS.TEXT = DE$: PUT #11, RE, DS
RETURN

WriteDesc3:
DS.TEXT = DE$: PUT #12, RE, DS
RETURN

WriteDesc4:
DS.TEXT = DE$: PUT #13, RE, DS
RETURN
'----------------------------------------------------
GetKey:
BS = POS(0): CC = 0
DO
   c = RND
   CC = CC + 1                           ' CC = Cursor Counter
   IF CC = CC1 THEN PRINT "/": LOCATE CSRLIN - 1, BS
   IF CC = CC2 THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
   IF CC = CC3 THEN PRINT "\": LOCATE CSRLIN - 1, BS: CC = 0
   a$ = UCASE$(INKEY$)
LOOP UNTIL a$ <> ""
PRINT a$: RETURN
'----------------------------------------------------
'  Keep input values in INTEGER range
'
NumInput:
GOSUB TextInput: x = INT(VAL(i$))
IF x > 32767 THEN i$ = "32767"
IF x < -32768 THEN i$ = "-32768"
RETURN
'**************************************************************************
'*                   Eamon Deluxe text editor v2.2                        *
'*                        by Frank Black 1999                             *
'*                                                                        *
'*   Variables to set before calling:                                     *
'*                                                                        *
'*       TL -- The desired length of the text string                      *
'*       i$ -- The text string to edit; Can be null ("") for new strings  *
'*  columns -- The # of columns to display in  (default=80)               *
'*      clr -- The current text color (default=7)                         *
'* TextHelp -- If anything but -1, valid key info is displayed            *
'*                (Help isn't displayed for strings < 20 in length)       *
'*                                                                        *
'*   Other variables used and/or changed by this subroutine:              *
'*                                                                        *
'*         sl -- String Length                                            *
'*          i -- Current location in i$                                   *
'*  TextHelp1 -- Used to preserve TextHelp setting on strings < 20        *
'*  col & row -- Present column and row on screen                         *
'* csr1, csr2 -- Row & column loc. when called (csr2 always reverts to 1) *
'*   a, a$, x -- Generic variables for procedures                         *
'**************************************************************************
TextInput:
IF columns = 0 THEN columns = 80
IF clr = 0 THEN clr = 7
TextHelp1 = TextHelp: IF tl < 20 THEN TextHelp1 = -1
csr2 = POS(0): PRINT : LOCATE CSRLIN - 1
csr1 = CSRLIN
IF csr2 + tl > columns THEN csr2 = 1
sl = LEN(i$): IF sl = 0 THEN i$ = " ": sl = 1
row = csr1: col = csr2: i = 1

LOCATE csr1, csr2: PRINT i$ + STRING$(tl - sl, 196)
IF TextHelp1 <> -1 THEN
  PRINT : PRINT "<Enter> Accepts all text left of cursor";
  IF columns < 80 THEN PRINT
  PRINT "        <Tab> Inserts a space": PRINT "  <Esc> Accepts ALL text"
  PRINT "<F1> Toggle extended text (under cursor)"
  PRINT "<F2> Toggle extended text (entire text)"
END IF

TextInput1:
LOCATE csr1, csr2: PRINT i$ + STRING$(tl - sl, 196)
'
TextInputLoop:
IF col > columns THEN col = 1: row = row + 1
IF col < 1 THEN col = columns: row = row - 1
IF row < csr1 THEN row = csr1: col = 1
IF i$ = "" THEN i$ = " ": sl = 1: i = 1
a2$ = MID$(i$, i, 1)
LOCATE row, col: COLOR 0, clr: PRINT a2$; :  COLOR clr, 0
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
LOCATE row, col: PRINT a2$; : LOCATE row, col
'
'    Sort key presses
'
a = ASC(RIGHT$(a$, 1))
IF LEN(a$) > 1 THEN
'
'   Left and Right arrows
'
  IF a = 75 THEN
    IF i = 1 THEN GOTO ErrorRtn
    IF RIGHT$(i$, 1) = " " THEN
      i$ = LEFT$(i$, sl - 1): sl = sl - 1: PRINT CHR$(196)
    END IF
    col = col - 1: i = i - 1
    GOTO TextInputLoop
  END IF
  IF a = 77 THEN
    IF i = tl THEN GOTO ErrorRtn
    IF i = sl THEN i$ = i$ + " ": sl = sl + 1
    i = i + 1: col = col + 1
    GOTO TextInputLoop
  END IF
'
'   Up and Down arrows
'
  IF a = 72 THEN
    IF row = csr1 THEN GOTO ErrorRtn
    i$ = RTRIM$(i$): sl = LEN(i$): row = row - 1: i = i - columns
    IF i > sl THEN col = col - (i - sl): i = sl
    GOTO TextInput1
  END IF
  IF a = 80 THEN
    IF row = INT(sl / columns) + csr1 THEN GOTO ErrorRtn
    IF i + columns > sl THEN GOTO ErrorRtn
    row = row + 1: i = i + columns
    GOTO TextInput1
  END IF
'
'  <Home> & <End>
'
  IF a = 71 THEN
    IF i = 1 THEN GOTO ErrorRtn
    i$ = RTRIM$(i$): sl = LEN(i$)
    i = 1: row = csr1: col = csr2: GOTO TextInput1
  END IF
  IF a = 79 THEN
    IF i = tl THEN GOTO ErrorRtn
    x = INT(sl / columns): row = csr1 + x: col = sl - x * columns
    i = sl: GOTO TextInputLoop
  END IF
'
'   Delete
'
   IF a = 83 THEN
     IF i = sl GOTO ErrorRtn
     i$ = MID$(i$, 1, i - 1) + MID$(i$, i + 1)
     sl = sl - 1
     GOTO TextInput1
   END IF
'
'  F1 and F2  (Toggles for extened/regular ASCII mode)
'
  IF a = 59 THEN
    x = 127: IF ASC(MID$(i$, i, 1)) > 127 THEN x = -x
    i$ = LEFT$(i$, i - 1) + CHR$(ASC(MID$(i$, i, 1)) + x) + MID$(i$, i + 1)
    GOTO TextInputLoop
  END IF
  IF a = 60 THEN
    a$ = ""
    FOR a = 1 TO sl
       x = 127: IF ASC(MID$(i$, a, 1)) > 127 THEN x = -x
       a$ = a$ + CHR$(ASC(MID$(i$, a, 1)) + x)
    NEXT
    i$ = a$: GOTO TextInput1
  END IF
  GOTO ErrorRtn
END IF
'
'   Backspace
'
IF a = 8 THEN
  IF i = 1 GOTO ErrorRtn
  i$ = MID$(i$, 1, i - 2) + MID$(i$, i)
  i = i - 1: sl = sl - 1: col = col - 1
  GOTO TextInput1
END IF
'
'    TAB key (insert space)
'
IF a = 9 THEN
  IF i = tl OR i = sl OR sl = tl THEN GOTO ErrorRtn
  IF i = 1 THEN i$ = " " + i$
  IF i > 1 THEN i$ = MID$(i$, 1, i - 1) + " " + MID$(i$, i)
  sl = sl + 1: LOCATE csr1, csr2: PRINT i$;
  GOTO TextInputLoop
END IF
'
'  <ENTER> accepts text from beginning to cursor)
'    <ESC> accepts all text)
'
IF a = 13 THEN
  i$ = LEFT$(i$, i - 1 * ABS(i < tl))
  GOTO TextInputDone
END IF
IF a = 27 THEN GOTO TextInputDone
'
'  Add valid characters to string
'
IF a < 32 THEN GOTO ErrorRtn
IF i = tl THEN
  i$ = MID$(i$, 1, i - 1) + a$: PRINT a$; : GOTO TextInputLoop
END IF
IF i < sl THEN
  IF i = 1 THEN i$ = a$ + MID$(i$, 2)
  IF i > 1 THEN i$ = MID$(i$, 1, i - 1) + a$ + MID$(i$, i + 1)
END IF
IF i = sl THEN
  i$ = LEFT$(i$, sl - 1) + a$ + " ": sl = sl + 1
END IF
i = i + 1: col = col + 1: PRINT a$; : GOTO TextInputLoop
'
'     Invalide keys/move
'
ErrorRtn:
SOUND 800, .5: GOTO TextInputLoop
'
'     Display string
'
TextInputDone:
a$ = "": IF TextHelp1 <> -1 THEN a$ = STRING$(425, 32)
LOCATE csr1, csr2: PRINT STRING$(tl, 32) + a$
i$ = RTRIM$(i$): LOCATE csr1, csr2: PRINT i$: PRINT
RETURN

