' THE WONDERFUL WORLD OF EAMON DELUXE EDITION (v2)
'           BY FRANK BLACK 1997-1999
'
'   A COMPUTERIZED FANTASY ROLE-PLAYING SYSTEM
' BASED UPON THE APPLE II VERSION BY DONALD BROWN,
'    JOHN NELSON, TOM ZUCHOWSKI, & FRANK BLACK
'
'            ADVENTURE INTRO PROGRAM
'
'  Updated 16 MAY 1999 (v2 conversion & condensed from 2 vol.)
'
'  The Donald Brown Adventures
'  By Donald Brown, EDX conversion by Frankus Blackus
'
DECLARE SUB FK.Logo ()

ON ERROR GOTO ErHndlr

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: A1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: SEX AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

DIM SHARED dly, CC1, CC2, CC3
OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly, CC1, CC2, CC3: CLOSE

OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): SEX = z.SEX
q$ = CHR$(34)
'
' Make sure EGA or VGA mode is available for Apple Island
'
ON ERROR GOTO ScreenError: CLS : SCREEN 7
Start:
ON ERROR GOTO ErHndlr: SCREEN 0: WIDTH 80
'
' Load Pac-Man shape
'
DIM SHARED pacman%(1 TO 100)
OPEN "shapes.dat" FOR INPUT AS #1
FOR x = 1 TO 46: INPUT #1, pacman%(x): NEXT
CLOSE

L$ = STRING$(80, 196)
OPEN "GAMEDIR.DAT" FOR INPUT AS #1
INPUT #1, a
CLOSE

author$ = "Converted to Eamon Deluxe by Frank Black"
adventure$ = "The Donald Brown Adventures": GOSUB Title
mp$(1) = "MINOTAUR.BAS": mp$(2) = "CASTLE.BAS"
mp$(3) = "DEATHSTR.BAS": mp$(4) = "CLONE.BAS"
mp$(5) = "MOLINAR.BAS": mp$(6) = "ISLAND.BAS"
mp$(7) = "FUEY.BAS": mp$(8) = "MISSION.BAS"
a$(1) = "The Lair of the Minotaur": a$(2) = "Castle of Doom"
a$(3) = "The Death Star": a$(4) = "Assault on the Clone Master"
a$(5) = "The Tomb of Molinar": a$(6) = "The Lost Island of Apple"
a$(7) = "The Castle of Count Fuey": a$(8) = "The Rescue Mission"

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu."
  PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE : CHDIR "..": RUN "STARTUP.BAS"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF
IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adventure$ = a$(adv1): mp$ = mp$(adv1): adv = adv1: author$ = "by Donald Brown"
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Lair, Castle, Death, Clonemaster, Molinar, Island, Fuey, Mission
GOTO IntroDone

'---------------------------------------------------------------------------
' Blast from the past
'
Intro:
CLS : WIDTH 40: COLOR 7
PRINT "  THE WONDERFUL WORLD OF EAMON DELUXE"
PRINT STRING$(40, "-")
PRINT "             BY FRANK BLACK"
s$ = STRING$(40, "*")
LOCATE 6: PRINT SPC(14); "ADVENTURE #2": PRINT
COLOR 0, 7
PRINT s$; "*"; SPC(38); "*";
PRINT "*"; SPC(6); "THE DONALD BROWN ADVENTURES";
PRINT SPC(5); "*";
PRINT "*"; SPC(38); "*"; s$
COLOR 7, 0: PRINT
PRINT SPC(12); "BY DONALD BROWN": PRINT : PRINT
PRINT "TO GO ON THESE ADVENTURES YOU MUST FIRST"
PRINT SPC(5); "MAKE SURE YOUR SWORD IS SHARP": PRINT : PRINT
PRINT " NON COMMERCIAL DISTRIBUTION ENCOURAGED": PRINT
PRINT "]"; : LOCATE 23, 1: k$ = INKEY$
FOR x = 1 TO dly * 20
   IF INKEY$ <> "" THEN x = dly * 20
NEXT
GOSUB KeyWait
CLS : WIDTH 80: COLOR 3

'---------------------------------------------------------------------------
'  First time intro
'
First:
GOSUB Title
a$ = "This is official Eamon Deluxe adventure #2": GOSUB Center: PRINT
PRINT "DONALD BROWN, THE FATHER OF EAMON.": PRINT
PRINT "Donald Brown wrote the original Eamon system for the Apple II in the early 80's"
PRINT "so that ordinary BASIC programmers could write their own adventure games, using"
PRINT "his Eamon software as a building block.  That was nearly twenty years ago,"
PRINT "making Eamon one of the oldest computer RPG systems."
PRINT
PRINT "While the Eamon Deluxe system is exceptionally different from Brown's original"
PRINT "version, it is still based heavily around his original formulas and database"
PRINT "structures.  And, aside from this, the first couple hundred Eamon Deluxe"
PRINT "adventures are all conversions of original Apple II Eamon adventures."
PRINT
PRINT : PRINT : GOSUB KeyWait
PRINT "Before moving on to commercial software, Don Brown wrote a total of nine Eamon"
PRINT "adventures:  The Beginner's Cave, The Lair of the Minotaur, Castle of Doom,"
PRINT "The Death Star, Assault on the Clone Master, The Tomb of Molinar, The Lost"
PRINT "Island of Apple, The Castle of Count Fuey, and The Rescue Mission."
PRINT
PRINT "The Beginner's Cave is included with the Eamon Deluxe Master, the other eight"
PRINT "are collected into The Donald Brown Adventures.  These versions are very close"
PRINT "to Brown's originals, however some changes were made to either enhance"
PRINT "playability or make the adventures run under Eamon Deluxe."
PRINT
PRINT "None of these adventures are very complex, nor do they have much in the way of"
PRINT "quests or puzzle-solving.  But I think that you'll find that each one has a"
PRINT "share of special events which make it at least interesting to play."
PRINT : PRINT : GOSUB KeyWait
PRINT "NOTES:"
PRINT
PRINT q$; "The Lost Island of Apple"; q$; " is a semi-graphic adventure that requires a color"
PRINT "graphics adapter.  I've included the program which displays and/or saves the"
PRINT "shapes in a file called "; q$; "SHAPES.DAT"; q$; ".  This can be selected from the main menu."
PRINT
PRINT "These adventures were among the first converted to Eamon Deluxe, so you may"
PRINT "notice that some routines and such aren't as advanced as in adventures converted"
PRINT "to a later Eamon Deluxe version."
PRINT
PRINT "I hope you enjoy these adventures, and the next time you're in the Main Hall,"
PRINT "buy a Double Dragon Blomb, slap the Irishman on the back, and make a toast to"
PRINT "the man who started it all.  Donald Brown, the father of Eamon."
PRINT
PRINT SPC(52); "Frank Black,"
PRINT SPC(52); "January 1997"
PRINT : PRINT : GOSUB KeyWait
Menu:
COLOR 2
PRINT a$(1); : LOCATE CSRLIN, 40: PRINT a$(3)
PRINT a$(2); : LOCATE CSRLIN, 40: PRINT a$(4)
PRINT a$(5); : LOCATE CSRLIN, 40: PRINT a$(7)
IF AppleIsland = 1 THEN COLOR 8
PRINT a$(6); : COLOR 2: LOCATE CSRLIN, 40: PRINT a$(8): COLOR 3: PRINT

PRINT " 1. Read intro stories"
PRINT " 2. Read adventure reviews"
PRINT " 3. View Apple Island shapes"
PRINT " 4. Play an adventure": PRINT
PRINT "Enter 1-4: "; : GOSUB KeyWait1: k = INT(VAL(k$))
IF k < 1 OR k > 4 THEN GOTO Menu
IF k <> 3 THEN GOSUB Pick
ON k GOTO Stories, Reviews, SS, IntroDone0

Stories:
IF adv = 6 AND AppleIsland = 1 THEN
  COLOR 14: PRINT "Unavailable.": COLOR 3: GOSUB KeyWait: GOTO Menu
END IF
ON adv GOSUB Lair, Castle, Death, Clonemaster, Molinar, Island, Fuey, Mission
GOTO Menu

Reviews:
ON adv GOSUB lair1, Castle1, Death1, Clonemaster1, Molinar1, Island1, Fuey1, Mission1
GOTO Menu

SS:
RUN "makeshp"

IntroDone0:
IF adv = 6 AND AppleIsland = 1 THEN GOTO Stories
ON adv GOSUB Lair, Castle, Death, Clonemaster, Molinar, Island, Fuey, Mission
IntroDone:
IF adv = 3 THEN PRINT "(Starting adventure...)"
IF adv <> 3 THEN PRINT "(Waking up the monsters...)"
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$
END
'----------------------------------------------------------------------------
'
'   Lair of the Minotaur
'
Lair:
GOSUB Title
x$ = "girlfriend": xx$ = "Larcenous Lil": xxx$ = "she"
IF SEX = 1 THEN
  x$ = "boyfriend": xx$ = "Slippery Sven": xxx$ = "he"
END IF
PRINT "You had arranged to meet in the town of Dunderhaven with your "; x$; ","
PRINT xx$; ".  When you arrived, you learned that "; xxx$; " had come into town flat"
PRINT "broke, and had tried to pick up some easy cash by burglarizing a nearby castle."
PRINT UCASE$(LEFT$(xxx$, 1)); MID$(xxx$, 2); " hasn't been seen since."
PRINT
PRINT "Making your own subtle entrance into the castle, all seemed to be going well"
PRINT "until suddenly the lights go on and you see yourself surrounded by bowmen and"
PRINT "a fat, ugly man on a throne.  He sneers at you and says, "; q$; "Well, boys, another"
PRINT "thief.  I guess we'll send this scoundrel to meet the first."; q$
PRINT
PRINT "With that, he pulls a lever, and the bottom drops out of the floor."
PRINT : PRINT : PRINT : PRINT
PRINT "-----------------------------------------------------------------------------"
PRINT : lair1 = 1: GOSUB KeyWait
'
' Trap door routine
'
LOCATE CSRLIN, 1: PRINT SPC(50); : LOCATE CSRLIN - 2, 26
PRINT SPC(20); : PRINT
FOR a = 500 TO 100 STEP -10
   LOCATE CSRLIN, 25
   PRINT "I"; SPC(20); "I"
   SOUND a, 1
   FOR x = 1 TO dly / 3: NEXT
NEXT
PRINT SPC(30); "--THUD!--": SOUND 50, 4
PRINT : PRINT : GOSUB KeyWait
'
PRINT "Author's notes:": PRINT
PRINT "The method of running Lair of the Minotaur is roughly the same as it was in the"
PRINT "Beginner's Cave.  Of course, the monsters and treasures and rooms are not the"
PRINT "same, and a command or two might be different, but why quibble?"
PRINT
PRINT "A major difference now is the fact that you will not know the way out.  A hint"
PRINT "to adventurer's: In cases like this, your top priority should be finding a way"
PRINT "out and mapping the dungeon.  Also, only a real louse would not at least try to"
PRINT "find a friend if they knew he or she was in their.  (Remember, louses do not"
PRINT "have very high charisma!)"
PRINT : PRINT : GOSUB KeyWait

RETURN

'----------------------------------------------------------------------------
'
'   Castle of Doom
'
Castle:
GOSUB Title
PRINT "The Castle of Doom is run by two kindly old ladies who want to give valiant"
PRINT "Adventurers a bit of excitement.  You will be traveling in a round castle just"
PRINT "chock-full of evil monsters and wonderful treasure."
PRINT : PRINT : GOSUB KeyWait
RETURN


'----------------------------------------------------------------------------
'
'  The Death Star
'
Death:
GOSUB Title
PRINT "As you left the Main Hall, you suddenly felt a queer wrench in your stomach,"
PRINT "as if you had been turned inside-out, then right again.  When things became"
PRINT "clear again, you found yourself at the helm of a spaceship!  You realize you"
PRINT "have gone through a reality-shift!"
PRINT
PRINT "You are in a parallel universe.  You must stay in this universe until you"
PRINT "fulfill some quest.  Although you have no access to your old gear, your body"
PRINT "is the same.  However, none of your old spells will work."
PRINT : PRINT : GOSUB KeyWait
PRINT "By searching new "; q$; "memories"; q$; ", you find out your situation, which isn't good!"
PRINT
PRINT "You are aboard the Millennium Falcon, which has just been dragged into the"
PRINT "Empire's evil machine of destruction, the Death Star!  To escape, you will have"
PRINT "to find and destroy the equipment in either the power machinery room or the"
PRINT "tractor beam machinery section."
PRINT
PRINT "You are equipped with a light-sabre."
PRINT
PRINT "Good luck, "; name$; "."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   Assault on the Clonemaster
'
Clonemaster:
GOSUB Title
PRINT SPC(20); "ASSAULT ON THE CLONE MASTER'S FORTRESS"
PRINT
PRINT "You were walking away from the Main Hall when you felt that unpleasant wrench"
PRINT "in your stomach again.  You are in another universe.  This time, you have your"
PRINT "normal body and weapons.  You just need to find your way back."
PRINT
PRINT "You came upon a group of people who knew of your plight.  They are rebels, and"
PRINT "can return you to your world.  They will show you the way, if you will only"
PRINT "first go with some of their men on a raid in the fortress of the dreaded"
PRINT "Clone Master."
PRINT
PRINT "When they inform you that they will kill you if you don't go along, you agree."
PRINT : PRINT : GOSUB KeyWait
PRINT "Before the rebels will return you home, you must do two things:  Kill the"
PRINT "Clone Master and destroy the device that keeps him in power, the Clonatorium!"
PRINT
PRINT "Three of their men will accompany you."
PRINT : PRINT : GOSUB KeyWait
RETURN

'----------------------------------------------------------------------------
'
'   The Tomb of Molinar
'
Molinar:
GOSUB Title
PRINT q$; "Molinar was"; q$; ", the King told you, "; q$; "the last of the Great Wizard-Kings.  He"
PRINT "ruled wisely for centuries, until he finally grew weary of this life.  He"
PRINT "prepared for himself a special chamber to sleep the endless rest in.  However,"
PRINT "he still loved the land he had ruled for so long, and he built his tomb so that"
PRINT "a worthy soul and valiant hero could call him forth again."
PRINT
PRINT q$; "The enemy has summoned forth a being of great power.  If the being runs"
PRINT "unchecked our kingdom is certainly doomed, possibly all of this globe as well."
PRINT "Not even our most powerful warriors can stop this creature.  Our only hope is"
PRINT "to call upon our great past leader.  You must find the tomb, enter it, and"
PRINT "bring back our savior."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT "So the King ordered you, and so you set out.  After weeks of searching, you"
PRINT "have found the Tomb of Molinar.  A magical message from the King tells you that"
PRINT "things are desperate.  You can't go for help, you must enter the tomb alone."
PRINT "Good luck, "; name$; "."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   The Lost Island of Apple
'
Island:
CALL FK.Logo
GOSUB Title
PRINT "You were in the infamous Dark Caverns when you ran into a huge dragon.  You saw"
PRINT "no chance of escaping, so-seeing there was no other way to survive-you tried"
PRINT "your Power spell.  You saw the scene shift before your eyes, and when everything"
PRINT "stopped moving, you found yourself in a very crude Main Hall."
PRINT
PRINT "     You find that you are trapped on "; q$; "Apple Island"; q$; ", in a remote and rarely"
PRINT "traveled part of the land of Eamon.  There is a wizard here who spoke to you"
PRINT "of the castle to the north, where it is rumored that there is a passage which"
PRINT "could take you home.  There is, however, a slight problem."
PRINT
PRINT "     It seems that there is a magic spell which has sealed the castle.  An"
PRINT "inscription informs all who want to know that, "; q$; "ALL WHO WISH TO ENTER THIS"
PRINT "CASTLE MUST HAVE THREERDS."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT "     The wizard also told you about an old temple dedicated to the god, Pashia"
PRINT "which lies to the south.  The temple may have a way out, or may have "; q$; "threerds"; q$
PRINT "(whatever they are).  There also may be other caves, caverns, and buildings to"
PRINT "explore on the island."
PRINT
PRINT "     As you explore the island, you will notice the large harbor to the east,"
PRINT "and the mountains to the northwest.  Beware of the monsters and evil men that"
PRINT "live on the island, but know that there are also men here who are good and true."
PRINT
PRINT "A final word of warning:  Be sure that you are kept well supplied with food."
PRINT "Every day, you and your friends must eat three meals or you will slowly die"
PRINT "from  starvation.  Every movement that you take lasts one third of a day."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'  The Castle of Count Fuey
'
Fuey:
GOSUB Title
PRINT "Baron Hador had thought that there was something odd about the man who had"
PRINT "collapsed in front of his castle.  But, being the kind soul that he is, he took"
PRINT "the man into his castle to spend the night."
PRINT
PRINT "The next morning it struck him-- The man looked a great deal like Jeeves, the"
PRINT "butler of Count Fuey.  No one trusted the renegade Count or any of his men."
PRINT
PRINT "The Baron ran into his guest room to evict the man, but he was too late.  The"
PRINT "man was gone, and a quick search of the castle showed that gone too were"
PRINT "certain private papers of the Baron's, the crest which signified the Baron's"
PRINT "right to rule, and his daughter Tanya!"
PRINT : PRINT : GOSUB KeyWait
PRINT "The Baron has asked you to recover the stolen items and rescue his young"
PRINT "daughter.  Knowing a little bit of magic, he will teleport you inside the castle"
PRINT "where you can search."
PRINT
PRINT "He told you he will be able to arrange a distraction that will keep the Count"
PRINT "out of his castle for an hour and a half.  You will be doomed if you are there"
PRINT "when he returns, therefore he will teleport you back when the time is up."
PRINT
PRINT "You agree to help the Baron.  He left the room to confer with his men, returned"
PRINT "in a few minutes, and said "; q$; "Remember, time is short.  Please do your best!"; q$
PRINT
PRINT "He waved a small rod and a thick smoke engulfed you..."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   Search for the Key/The Rescue Mission
'
Mission:
GOSUB Title
a$ = "Part 1 -- The Search for the Key": GOSUB Center
PRINT : PRINT "Congratulations, "; name$; ".": PRINT
PRINT "     You were just selected to undertake a very dangerous mission for the king."
PRINT "Several high officials were kidnapped from their beds last week.  Your job:"
PRINT "Rescue them."
PRINT
PRINT "     The king's warlock has devised a plan that should make your job nearly"
PRINT "easy.  However, for it to succeed, you must first possess the fabled Key of"
PRINT "Molinar."
PRINT : PRINT : GOSUB KeyWait
PRINT "     The key is a magical teleportation device.  If someone holds it, then says"
PRINT "the name of someone in sight who is willing, the person named is zapped to the"
PRINT "speaker's home.  This can also work for the speaker."
PRINT
PRINT "     Nobody knows where the key currently lies.  However, the warlock has a"
PRINT "spell which will teleport you to the key's vicinity.  Getting back is up to"
PRINT "you!"
PRINT
PRINT "     You are advised by the warlock to get the key as soon as possible, and use"
PRINT "it to return.  If you succeed at this leg of your assignment, a handsome reward"
PRINT "will be included in your booty.  Go now, and seek the Key of Molinar."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   Lair of the Minotaur review
'
lair1:
s$ = "June 1995": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30-90 min."
PRINT "Reviewer Rating: 5.0       Average Rating: 4.5/6"
PRINT
PRINT "Comment: Your quest is to find your friend and get out alive.  This adventure"
PRINT "can perhaps be described as an "; q$; "advanced Beginner's Cave"; q$; ".  With about 90"
PRINT "rooms, it is fairly large.  There are several neat little events and specials"
PRINT "that aren't exactly world-class but do make it more interesting to play."
PRINT
PRINT "All in all, a pretty good second adventure for beginners.  I put the difficulty"
PRINT "at (5), for a couple of death traps and a pretty decent maze.  The monsters are"
PRINT "pushovers for an advanced character, but plenty tough for beginners."
PRINT : PRINT : GOSUB KeyWait
RETURN

'----------------------------------------------------------------------------
'
'   Castle of Doom review
'
Castle1:
s$ = "June 1995": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30-60 min."
PRINT "Reviewer Rating: 4.0       Average Rating: 4.6/6"
PRINT
PRINT "Comment: This is yet another Eamon in the mold of the early ones:  simply laid"
PRINT "out, with minimal quest and no plot development.  This is primarily a standard"
PRINT q$; "kill 'n' loot"; q$; " scenario."
PRINT
PRINT "I enjoyed a couple of clever specials.  There is a vampire, and lots of"
PRINT "vampire-related paraphernalia strewn about.  Given all the stuff, I expected"
PRINT "something special, but didn't really see anything."
PRINT
PRINT "This is a relaxing foray, suitable for young Adventurers.  I give it a (4) for"
PRINT "difficulty."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'  The Death Star review
'
Death1:
s$ = "June 1994": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 1-2 hr."
PRINT "Reviewer Rating: 6.0       Average Rating: 4.0/8"
PRINT
PRINT "Comment: There are two important downsides to the play:  the lack of a HEAL"
PRINT "command makes survival very difficult, and there are at least four no-warning"
PRINT "death traps.  Another downside for me personally was that nearly every room"
PRINT "contains one to ten "; q$; "soldiers"; q$; " who must be killed.  The soldiers are cardboard"
PRINT "cutouts who are lousy fighters and die with a single blow, and I found it"
PRINT "rather tedious to have to clean them out with every move to a new room."
PRINT : PRINT : GOSUB KeyWait
PRINT "So why did I rate this highly?  Except for the endless procession of soldiers,"
PRINT "it is a pretty decent simulation of the Death Star portion of Star Wars, and I"
PRINT "made vigorous use of the cheating methods described in the December issue!  I"
PRINT "must state for the record that if I couldn't have cheated, I probably would have"
PRINT "given it a rating of about (3)."
PRINT
PRINT "Though the intro mentions a quest, there isn't one other than simple escape."
PRINT "However, you can make your own quest by making it a point to rescue Leia,"
PRINT "Chewie, and the 'droids.  Han Solo, Luke, and Obie-Wan are missing from the cast"
PRINT "so don't bother looking for them."
PRINT
PRINT "The difficulty can vary dramatically, but I think that a rating of (8) may be"
PRINT "close to what most people will see during play."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   Assault on the Clone Master review
'
Clonemaster1:
GOSUB Title
PRINT "No reviews presently exist for "; q$; adventure$; q$; "."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   The Tomb of Molinar review
'
Molinar1:
GOSUB Title
PRINT q$; "The Tomb of Molinar"; q$; " was review in the March 1995 issue of the EAG"
PRINT "newsletter.  However, the review dealt only with problems and features of the"
PRINT "Apple II version so it wasn't included here."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   The Lost Island of Apple review
'
Island1:
PRINT "No reviews presently exist for "; q$; adventure$; q$; "."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'  The Castle of Count Fuey review
'
Fuey1:
PRINT "No reviews presently exist for "; q$; adventure$; q$; "."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'
'   Search for the Key & The Rescue Mission reviews
'
Mission1:
GOSUB Title
s$ = "December 1994": GOSUB Review1
COLOR 2: a$ = "Part 1:  The Search for the Key": GOSUB Center: COLOR 3: PRINT
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 15 min."
PRINT "Reviewer Rating: 4.0       Average Rating: 4.2/4"
PRINT : PRINT : PRINT : PRINT : GOSUB KeyWait
'
COLOR 2: a$ = "Part 2:  The Rescue Mission": GOSUB Center: COLOR 3: PRINT
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 6.0       Average Rating: 6.7/3"
PRINT
PRINT "Comment: The 53-Room map is a simple collection of uninteresting corridors and"
PRINT "cells, and the bad guys nearly all have names like 'Goon19'.  There is a large"
PRINT "group of people to rescue who are spread all through the map."
PRINT
PRINT "Except for killing umpteen goons, there isn't a lot to do or solve here, so it"
PRINT "gets a difficulty rating of (4) from me.  One hint:  there's no need to wait to"
PRINT "teleport the prisoners home."
PRINT : PRINT : GOSUB KeyWait
RETURN
'----------------------------------------------------------------------------
'  Review header
'
Review1:
GOSUB Title
COLOR 2
PRINT "The Eamon Adventurer's Guild"
PRINT "Thomas Zuchowski, Editor"
PRINT "7625 Hawkhaven Dr."
PRINT "Clemmons, NC  27012      (910) 766-7490"
COLOR 3: PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version.": PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people.": PRINT
PRINT "Remember, these reviews were written for the OLD versions of these adventures!"
PRINT : PRINT : GOTO KeyWait

'----------------------------------------------------------------------------
' Select adventure
'
Pick:
GOSUB Title: PRINT "Select adventure:": PRINT
FOR x = 1 TO 8
PRINT RTRIM$(STR$(x)); ": "; a$(x)
NEXT
PRINT "Enter 1-8: "; : GOSUB KeyWait1: adv = INT(VAL(k$))
IF adv < 1 OR adv > 8 THEN GOTO Pick
adventure$ = a$(adv): mp$ = mp$(adv)
author$ = "by Donald Brown"
RETURN

'----------------------------------------------------------------------------
' Wait for keypress
'
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$
BS = POS(0): CC = 0
DO
   CC = CC + 1                           ' CC = Cursor Counter
   IF CC = CC1 THEN PRINT "/": LOCATE CSRLIN - 1, BS
   IF CC = CC2 THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
   IF CC = CC3 THEN
     PRINT "\": LOCATE CSRLIN - 1, BS: CC = 0
   END IF
   k$ = INKEY$
LOOP UNTIL k$ <> ""
IF lair1 = 1 THEN lair1 = 0: RETURN

'----------------------------------------------------------------------------
' Clear screen and print adventure name and author
'
Title:
CLS
a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT L$: PRINT : RETURN

'----------------------------------------------------------------------------
' Center a string on 80-column screen
'
Center:
PRINT SPC((79 - LEN(a$)) / 2); a$
RETURN
'---------------------------------------------------------------------------
' Can't initialize graphics screen
'
ScreenError:
SCREEN 0: WIDTH 80: CLS : AppleIsland = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able to play the adventure, "; q$; "Apple Island"; q$; ", because it requires"
PRINT "an EGA or VGA graphics display.": PRINT : PRINT
GOSUB KeyWait: RESUME Start

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : PRINT "Program terminated.": RESUME ErHndlr1
ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

SUB FK.Logo
SCREEN 7: CLS : LOCATE 5, 8: COLOR 10
a$ = "The Lost Island of Apple": GOSUB SlowPrint

COLOR 9: LOCATE 10, 1
a$ = "Shapes and images by Donald Brown.": GOSUB SlowPrint
GOSUB KeyWaitx

y = 20: GOSUB Animate: y = 50: GOSUB Animate: z = 0: y = 70: GOSUB Animate
y = 100
FOR x = 0 TO 110 STEP 5
   GOSUB SDraw
   FOR a = 1 TO dly / 30: NEXT
   GOSUB Serase
NEXT
GOSUB SDraw

COLOR 9: LOCATE 10, 3
a$ = "IBM-PC graphics programmed": GOSUB SlowPrint
LOCATE 11, 9: a$ = "by Frank Black": GOSUB SlowPrint
GOSUB KeyWaitx: SCREEN 0: WIDTH 80: CLS : COLOR 3
EXIT SUB
'---------------------------------------------
' Make Pac-Man eat writing
'
Animate:
FOR x = 0 TO 300 STEP 5
   GOSUB SDraw
   FOR a = 1 TO dly / 30: NEXT
   GOSUB Serase
NEXT
RETURN
'
' Draw Pac-Man
'
SDraw:
PUT (x, y), pacman%, PSET
IF y = 70 THEN
  IF z = 0 THEN SOUND 50, 1
  z = z + 1: IF z = 3 THEN z = 0
END IF
RETURN
'
' Erase Pac-Man
'
Serase:
PUT (x, y), pacman%, XOR
RETURN
'
' Simulate Apple II "SPEED" command
'
SlowPrint:
FOR a = 1 TO LEN(a$)
   PRINT MID$(a$, a, 1);
   FOR z = 1 TO dly / 5: NEXT
NEXT
PRINT : RETURN
'
' Wait for keypress
'
KeyWaitx:
COLOR 4: LOCATE 23: PRINT "Press any key to continue...";
k$ = INKEY$: BS = POS(0): CC = 0
DO
   CC = CC + 1                           ' CC = Cursor Counter
   IF CC = CC1 THEN PRINT "/": LOCATE CSRLIN - 1, BS
   IF CC = CC2 THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
   IF CC = CC3 THEN PRINT "\": LOCATE CSRLIN - 1, BS: CC = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""
LOCATE CSRLIN, 1: PRINT SPC(38); : RETURN
END SUB

