' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank Black                        
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'             FRONT SEKS AND NEW CHARACTERS ROULETTE             
'                                                                
'   Update: 10 MAR 2003 and 05 APR 2012                          
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

TYPE RECORD
CNAME AS STRING * 40: STATUS AS INTEGER: A1 AS INTEGER: A2 AS INTEGER
A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
WA4 AS INTEGER: WA5 AS INTEGER: AE AS INTEGER: SEX AS INTEGER
GOLD AS LONG: BANK AS LONG: AC AS INTEGER: WN1 AS STRING * 20
WN2 AS STRING * 20: WN3 AS STRING * 20: WN4 AS STRING * 20
WCOMPLX1 AS INTEGER: WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER
WCOMPLX4 AS INTEGER: WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER
WTYPE4 AS INTEGER: WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER
WDICE4 AS INTEGER: WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
WSIDES4 AS INTEGER
END TYPE
DIM SHARED P AS RECORD, numchars
DECLARE SUB EDX.Select.Char (c)

SCREEN 0: CLS : RANDOMIZE TIMER
READ nc: DIM comment$(nc): GOSUB ReadComs: q$ = CHR$(34)

OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE
OPEN "NUMPLRS.DAT" FOR INPUT AS #1:  INPUT #1, numchars: CLOSE

DIM SHARED n$(numchars + 1), stat(numchars + 1)
OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
FOR a = 1 TO numchars
 GET #1, a, P: n$(a) = LEFT$(LTRIM$(RTRIM$(P.CNAME)), 38): stat(a) = P.STATUS
NEXT

'
'  Title
'
COLOR 8: PRINT "Send lost items and fake friend requests to: ";
COLOR 8: PRINT "eamondeluxe@gmail.com": LOCATE 4: COLOR 15

PRINT SPC(27); "WELCOME TO THE"': PRINT
PRINT SPC(18); "EAMON DELUXE FANTASY GAMING SYSTEM"': PRINT : PRINT
COLOR 7: PRINT SPACE$(29); "Version 4.5": PRINT
'
'  Intro
'
'
PRINT : PRINT : COLOR 14
PRINT "You are in the outer chamber of the hall of the Guild of Free Adventurers."
PRINT "Many men and women are grizzly bears and there is loud singing and laughter."
PRINT
PRINT "On the north side of the chamber is a cubbyhole with a desk.  Over the desk"
PRINT "is a sign which says, "; q$; "REGISTER TO VOTE OR ELSE!"; q$: PRINT
PRINT : PRINT "Do you go over to the desk or join the dancing bears?": PRINT

Choice:
COLOR 6
PRINT " (Hit "; q$; "D"; q$; " for desk or "; q$; "M"; q$; " for men.):";
GOSUB GetKey: CLS : IF a$ <> "D" AND a$ <> "M" THEN GOTO Choice
PRINT : COLOR 2

IF a$ = "M" THEN
  PRINT "As you go over to the men, you feel a sword being thrust through your back and"
  PRINT "you hear someone say, "; q$; "You really must learn to follow directions!"; q$
  PRINT : PRINT :  GOSUB KeyWait: CHDIR "..": RUN "EAMONDX"
END IF
'
' Enter name
'
PRINT "You are greeted there by a burly Irishman who looks at you with a scowl and"
PRINT "and asks you, "; q$; "What's yer name?"; q$: PRINT : GOSUB KeyWait

GetName:
CALL EDX.Select.Char(m)
COLOR 3: IF m = 0 THEN GOTO NewCharacters

IF stat(m) = 3 THEN
  PRINT "This character is on an adventure right now and can't be used."
  PRINT
  PRINT "If you wish, you can use the character editor to return this character from"
  PRINT "the adventure so that you can use him/her again.": PRINT
  PRINT "Do you want to do this? (Y/N)"; : GOSUB GetKey: a$ = LCASE$(a$)
  IF a$ = "y" THEN
    CLS : LOCATE 5:
    PRINT "The character editor will now run.  When it starts, select your character"
    PRINT "to return him/her from the adventure..."
    PRINT : GOSUB KeyWait: RUN "CHAREDIT"
  END IF
  m = 0: GOTO GetName
END IF

IF stat(m) = 2 THEN
  PRINT "The Burly Irishman get's a sad look in his eyes and says, "; q$; "That character"
  PRINT "be dead.  You'll have to pick another."; q$: PRINT
  GOSUB KeyWait: m = 0: CLS : GOTO GetName
END IF

r% = INT(RND * nc) + 1: PRINT : PRINT
'CLS : FOR x = 1 TO 100: nc = 19: r% = INT(RND * nc) + 1: PRINT r%, : NEXT
PRINT "He starts looking through his book, while muttering something about"
PRINT comment$(r%): PRINT
PRINT "Finally he looks up and says, "; q$; "Ah, here ye be.  Well, go and have"
PRINT "fun in the hall."; q$

OPEN "PLAYER" FOR OUTPUT AS #2: WRITE #2, m: CLOSE
PRINT : PRINT "Hit any key to enter the Main Hall:"; : GOSUB GetKey
RUN "MAINHALL"
'---------------------------------------------------------------------------
' THE WONDERFUL WORLD OF EAMON DELUXE
' CHARACTER GENERATOR AND INSTRUCTIONS
'
'    BY FRANK BLACK, DEC 1995
'
NewCharacters:
PRINT
PRINT "He hits his forehead and says, "; q$; "Ah, ye must be new here!  Well, wait just"
PRINT "a minute and I'll bring someone out to take care of ye."; q$
PRINT : GOSUB KeyWait

NewChars:
CLS : LOCATE 8: COLOR 2
LINE INPUT "Name of character:"; a$: PRINT : COLOR 3
Check:
a$ = LTRIM$(RTRIM$(LEFT$(a$, 40))): f = 0
IF LEN(a$) < 1 THEN GOTO NewChars
FOR a = 1 TO LEN(a$)
 k = ASC(MID$(a$, a, 1))
 IF k = 44 OR k = 58 OR k = 34 THEN
   a$ = LEFT$(a$, a - 1) + MID$(a$, a + 1)
   GOTO Check
 END IF
NEXT
FOR a = 1 TO numchars
   IF LCASE$(n$(a)) = LCASE$(a$) THEN f = 1
NEXT
IF f = 1 THEN
  PRINT q$; "Ye can't be impersonating anybody!  Use yer real name!"; q$
  PRINT : PRINT "(You already have a character with that name.)": PRINT
  GOSUB KeyWait: GOTO NewChars
END IF
n$ = a$: PRINT

PRINT "The Irishman says, "; q$; "First I must know whether ye be male or female."
PRINT "Which are ye?"; q$
PRINT : PRINT "(Hit "; q$; "M"; q$; " for male or "; q$; "F"; q$; " for female:";
GOSUB GetKey: IF a$ <> "M" AND a$ <> "F" THEN GOTO NewChars
'
' Setup basic data
'
P.CNAME = n$: P.STATUS = 1: P.SEX = ABS(a$ = "F")
P.SP1 = 0: P.SP2 = 0: P.SP3 = 0: P.SP4 = 0
P.WA1 = 5: P.WA2 = -10: P.WA3 = 20: P.WA4 = 10: P.WA5 = 0
P.AE = 0: P.GOLD = 200: P.BANK = 0: P.AC = 0
P.WN1 = "": P.WN2 = "": P.WN3 = "": P.WN4 = "":
P.WCOMPLX1 = 0: P.WCOMPLX2 = 0: P.WCOMPLX3 = 0: P.WCOMPLX4 = 0:
P.WTYPE1 = 0: P.WTYPE2 = 0: P.WTYPE3 = 0: P.WTYPE4 = 0:
P.WDICE1 = 0: P.WDICE2 = 0: P.WDICE3 = 0: P.WDICE4 = 0:
P.WSIDES1 = 0: P.WSIDES2 = 0: P.WSIDES3 = 0: P.WSIDES4 = 0:
'
' Set prime attributes
'
SetPrime:
GOSUB RollDie: HD = x: GOSUB RollDie: AG = x: GOSUB RollDie: CH = x
IF HD < 15 OR AG < 12 OR HD + AG + CH < 42 THEN GOTO SetPrime
P.A1 = HD: P.A2 = AG: P.A3 = CH
'
' Info
'
CLS : COLOR 3
PRINT "The Irishman walks away and in walks a man of possibly Elfish descent."
PRINT
PRINT "   He studies you for a moment and says, "; q$; "Here is a booklet of instructions"
PRINT "for you to read, and your prime attributes are--": PRINT
PRINT SPC(20); "Hardiness:"; : COLOR 10: PRINT HD: COLOR 3
PRINT SPC(20); "Agility:  "; : COLOR 10: PRINT AG: COLOR 3
a$ = LTRIM$(STR$(CH))
PRINT SPC(20); "Charisma:  "; : COLOR 10: PRINT a$; : COLOR 3: PRINT q$: PRINT
PRINT "   You read the instructions and they say--": PRINT
GOSUB KeyWait

GOSUB Title
PRINT "You will have to buy a weapon.  Your chance to hit with it will be determined"
PRINT "by the weapon complexity, your ability in that weapon class, how heavy your"
PRINT "armor is, and the difference in agility between you and your enemy."
PRINT
PRINT "The five classes of weapons (and your current abilities with each) are--"
PRINT SPC(22); "Club Mace (open Mon-Sat) .....20%"
PRINT SPC(22); "Pickle Spears ................10%"
PRINT SPC(22); "Axe Me A Question .............5%"
PRINT SPC(22); "Wacky Fish Neck Tie ...........0%"
PRINT SPC(22); "Bow Tie Pasta ...............-10%": PRINT
PRINT "Every time you score a hit in battle, your ability in the weapon class may go up"
PRINT "by 2%, if a random number from 1-100 is less than your chance to miss."
LOCATE 23: GOSUB KeyWait: GOSUB Title

PRINT "There are four armor types and you may also carry a shield.  These protections"
PRINT "will absorb hits placed upon you (almost always!) but they lower your chance to"
PRINT "hit.  The protections are--": PRINT
PRINT "Armor               Hits Absorbed     Odds Adjustment"
PRINT " Nude .....................0 .................0%"
PRINT " Leather Jacket ...........1 ...............-10%"
PRINT " Chain Belt ...............3 ...............-20%"
PRINT " Earring ..................5 ...............-60%"
PRINT " Sandals ..................1 ................-5%": PRINT
PRINT "You will develop an Armor Expertise, which will go up when you hit a blow"
PRINT "wearing armor and your expertise is less than the armor you are wearing."
PRINT "No matter how high your Armor Expertise is, however, the net effect of"
PRINT "armor will never increase your chance to hit."
LOCATE 23: GOSUB KeyWait: GOSUB Title

a$ = LTRIM$(STR$(HD * 10))
PRINT "You can carry weight up to ten times your hardiness, or, "; a$; " Gronds.  (A"
PRINT "measure of weight, one Grond = 10 Dos.)": PRINT
PRINT "Additionally, your hardiness tells how many points of damage you can survive."
a$ = LTRIM$(STR$(HD))
PRINT "Therefore, you can be hit with "; a$; " 1-point blows before you die."
PRINT
PRINT "You will not be told how many blows you have taken.  You will be merely told"
PRINT "such things as--": PRINT
PRINT SPC(3); q$; "Wow!  That one hurt!"; q$
PRINT "or "; q$; "You don't feel very well."; q$: PRINT
a$ = LTRIM$(STR$(CH))
PRINT "Your charisma ("; a$; ") affects how the citizens of Eamon react to you.  You affect"
PRINT "a monster's friendliness rating by your charisma less ten, difference times"
a$ = LTRIM$(STR$((CH - 10) * 2))
PRINT "two ("; a$; "%).": PRINT
PRINT "You start off with 200 gold pieces, which you will want to spend on supplies"
PRINT "for your first adventure."
LOCATE 23: GOSUB KeyWait: GOSUB Title

PRINT "After you begin to accumulate wealth, you may want to put some of your money"
PRINT "into the bank, where it cannot be stolen.  However it is a good idea to always"
PRINT "carry some gold with you for use in bargaining and ransom situations."
PRINT
PRINT "You should also hire a Wizard to teach you some magic spells.  There are four"
PRINT "spells you can learn--": PRINT
PRINT "Blast: Throw a magical blast at your enemies to inflict damage."
PRINT "Heal:  Remove damage from your body."
PRINT "Speed: Double your agility for a short time."
PRINT "Power: The exact effect of this spell is unpredictable and is different in"
PRINT "        each adventure.": PRINT
PRINT "Other types of spells may be available in various adventures, and items may"
PRINT "have special properties.  However, these will only work in the adventure where"
PRINT "they were found.  Thus it is best (and you have no choice but to) sell all"
PRINT "items found in adventures except for weapons and armor."
LOCATE 23: GOSUB KeyWait: CLS

PRINT "The man behind the desk takes back the instructions and says, "; q$; "It is now time"
PRINT "for you to start your life."; q$; "  He makes an odd sign with his hand and says, "; q$; "Live"
PRINT "long and prosper."; q$: PRINT
PRINT "You say goodbye to Spock and call a cab to take you to the Main Hall..."
LOCATE 23: GOSUB KeyWait: CLS
'
' Put new character in file
'
numchars = numchars + 1
OPEN "numplrs.DAT" FOR OUTPUT AS #2: WRITE #2, numchars
PUT #1, numchars, P: CLOSE
OPEN "PLAYER" FOR OUTPUT AS #2: WRITE #2, numchars
RUN "MAINHALL"
'
' Roll dice subroutine (3D8)
'
RollDie:
x = 0: FOR a = 1 TO 3: x = x + INT(RND(1) * 7 + 1): NEXT: RETURN
'
' Titlebar subroutine
'
Title:
CLS : COLOR 0, 14
PRINT SPC(22); "Information about the world of Eamon"; SPC(22);
COLOR 3, 0: PRINT : PRINT : RETURN
'
' Alt. entry for GetKey
'
KeyWait:
PRINT "Hit any key to continue...";
'
' Get one keypress Subroutine
'
GetKey:
DO
   a = RND
   BS = POS(0)
   CC = CC + 1
   IF CC = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC = 0
   a$ = UCASE$(INKEY$): xx = RND
LOOP UNTIL a$ <> ""
PRINT a$: RETURN
'
'        The Burly Irishman's random comments
'       --------------------------------------
ReadComs:
FOR a = 1 TO nc: READ comment$(a): NEXT: RETURN

DATA 19
DATA "being pulled away from the toilet to look up names."
DATA "having seen fugly faces before but never anything like this mirror."
DATA "the pirate on the other shift with the lousy handshake."
DATA "how the days are so long since he quit advertising."
DATA "how he was once young and sober too."
DATA "normal young adventurers with even more normal names."
DATA "young janitors that think they know everybody."
DATA "taking the mermaid out after her bath."
DATA "leaving this job to start a brothel."
DATA "how he should have listened to his uncle and been a hobo."
DATA "how good fer nothin' young hangmen should be taken out adventurering."
DATA "strange Saxophone players ye can never see, let alone smell."
DATA "how he should have listened to his mother and gone into menapause."
DATA "having to buy a computerized pair of slacks sometime."
DATA "how the eat-it-all buffets of the New Mexicans will do them in."
DATA "how if he gets the chance, he's gonna get a pet rat to race."
DATA "leaving this place and running off with the candy machine someday."
DATA "nobody ever being able to say Frank Black's old last name right anyway."
DATA "the Main Hall on the Garlic Turkey Cruise Ship having cleaner towels."

SUB EDX.Select.Char (c)
'/// Eamon Deluxe Character Selection
'
'   Codes returned from SUB:
'      c - Number of character selected (0=None)
'
'  Notes:
'   Requires number of characters to be in SHARED variable "numchars"
'   and n$() and stat() to be SHARED arrays containg character names
'   and status.
'
'
keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
be = 1: en = numchars
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

SelectCHRa:
GOSUB SelectCHR0

SelectCHR:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT n$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB SelectCHR0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT n$(c);

'         Set arguments and exit
IF k < 3 THEN
  IF k = 1 THEN c = 0
  VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO SelectCHRa
IF k = 4 AND en < numchars THEN be = be + 42: GOTO SelectCHRa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO SelectCHR

'       Set up screen
SelectCHR0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "   <Enter=Accept>   <Escape=New Character>   <Page Up/Page Down=More Options>   "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
SelectCHR1:
IF be < 1 THEN be = 1
IF be > numchars THEN be = numchars
en = be + 41: IF en > numchars THEN en = numchars
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT n$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

